#!/bin/sh
#
# Hinweise:
# Den Befehl chmod u+x für gb3_svn.sh nicht vergessen!
# Mit 'chmod u+x gb3_svn.sh' hat nur der Besitzer der sh-Datei Ausführungsrechte. 
# Im Anschluss nicht vergessen: 
# Einen Starter für GAMBAS3 anlegen und den Pfad anpassen!  
# Befehl: gnome-terminal -e "/home/hans/8-SH/gb3_svn.sh"
#
SetConstants() {
	QUELLE="https://gambas.svn.sourceforge.net/svnroot/gambas/gambas/trunk/"
	HOME_PFAD=$HOME
	GB3_PFAD="gb3_trunk"
	ZIEL=$HOME_PFAD/$GB3_PFAD
	#
	RO="\033[31m"        	# rot
	GR="\033[32m"        	# grün
	FWG="\033[1;42;37m" 	# fett + weiß + grüner Hintergrund
	FWB="\033[1;47;44m" 	# fett + weiß + blauer Hintergrund
	NO="\033[0m"         	# normal (schwarz auf weiß - default)
}

SetLocalDirectory() {
  cd $ZIEL
}

GetRevisions() {
  echo "${FWG}Bitte warten Sie einen kleinen Augenblick ..."
  echo "Die Nummer der aktuellen Revision auf dem Server wird ermittelt!${NO}"
  echo
  REVISIONLOKAL=`svn info | awk '$1 ~ /^Revision:$/ {print $2;}'`
  REVISIONSERVER=`svn info -r HEAD | awk '$1 ~ /^Revision:$/ {print $2;}'`
  echo "Aktuelle Revision: $REVISIONSERVER"
  echo
}

Start() {
echo
  echo "*******************************************************************************"
  echo
  echo "${FWG}Installation von GAMBAS über SVN${NO}"
  echo "${FWG}Installation der 'Development Packages' unter Root-Rechten mit ENTER starten...${NO}";
  echo
  echo "*******************************************************************************"
  echo
  read a
}

StartUpdate() {
  echo
  echo "*******************************************************************************"
  echo
  echo "${FWG}GAMBAS-UPDATE Revision mit ENTER starten...${NO}";
  echo
  echo "*******************************************************************************"
  #echo
  read a
}

SetDevelopmentPackages() {
  # Gilt für UBUNTU 12.04 LTS
  sudo apt-get install build-essential autoconf libbz2-dev libfbclient2 libmysqlclient-dev \ 
  unixodbc-dev libpq-dev libsqlite0-dev libsqlite3-dev libgtk2.0-dev libldap2-dev libcurl4-gnutls-dev \ 
  libgtkglext1-dev libpcre3-dev libsdl-sound1.2-dev libsdl-mixer1.2-dev libsdl-image1.2-dev libsage-dev \ 
  libxml2-dev libxslt1-dev libbonobo2-dev libcos4-dev libomniorb4-dev librsvg2-dev libpoppler-dev \ 
  libpoppler-glib-dev libasound2-dev libesd0-dev libdirectfb-dev libaa1-dev libxtst-dev libffi-dev \ 
  kdelibs5-dev firebird2.1-dev libqt4-dev libglew1.5-dev libimlib2-dev libv4l-dev libsdl-ttf2.0-dev \ 
  libgnome-keyring-dev libgdk-pixbuf2.0-dev linux-libc-dev libgsl0-dev
}

GetLocalRevision() {
  echo
  echo "${FWG}Lokale Kopie des Subversion-Repository mit ENTER anlegen. Bitte warten!${NO}"
  echo
  read a
  #Syntax: svn checkout QUELLE ZIEL 
  svn checkout ${QUELLE} ${ZIEL}
}

GetUpdateLocalRevision() {
  echo
  echo "${FWG}Update der lokalen Kopie des Subversion-Repository mit ENTER anlegen. Bitte warten!${NO}"
  echo
  read a
  svn update
}

GetReconf_All() {
  echo
  echo "${FWG}Weiter mit ENTER! ( Ausgeführt wird './reconf-all' )${NO}"
  echo
  read a
  ./reconf-all
}

GetConfigure_C() {
  echo
  echo "${FWG}Weiter mit ENTER! ( Ausgeführt wird './configure -C'  )${NO}"
  echo
  read a
  # Der folgende Befehl analysiert das System und konfiguriert das Quellcode-Paket (Standard).
  #./configure -C
  #Alternative - Hinweisen auf Warnungen kommt man so schnell auf der Spur ... und wird genutzt
  ./configure -C | grep WARNING
}

GetMake() {  
  # Wenn alles ohne Fehler konfiguriert ist, dann wird jetzt der Befehl make ausgeführt.
  echo
  echo "${FWG}Weiter mit ENTER! ( Ausgeführt wird 'make' )${NO}";
  echo
  read a
  make
}

GetMakeInstall() {
  # Wenn alles ohne Fehler übersetzt wurde, dann wird GAMBAS3 
  # mit dem nächsten Befehl unter Root-Rechten installiert.
  echo
  echo "${FWG}Weiter mit ENTER! ( Ausgeführt wird 'sudo make install' )${NO}";
  echo
  read a
  sudo make install;
  echo
  echo "${FWG}Ende der Installation von GAMBAS - Abschluss mit ENTER!${NO}";
  echo
  read a
}

# Main-Program ############################################################################


SetConstants
if [ ! -d "$ZIEL" ]
then  
  Start
  SetDevelopmentPackages
  GetLocalRevision
  SetLocalDirectory
  GetReconf_All
  GetConfigure_C
  GetMake
  GetMakeInstall
else
  StartUpdate
  SetLocalDirectory
  GetRevisions
  if [ $((REVISIONSERVER - REVISIONLOKAL)) -gt 0 ];
  then
    echo "Gambas SVN - Revision LocalDirectory (Last): $REVISIONLOKAL"
    echo "Gambas SVN - Revision Server (New): $REVISIONSERVER"
    GetUpdateLocalRevision
    GetReconf_All
    GetConfigure_C
    GetMake
    GetMakeInstall
  else
    echo "Es existiert keine neue GAMBAS-Version!"
    echo "Abbruch mit ENTER!"
    read a
    exit 
  fi
fi

